package com.fr.plugin.cafe_expand.designerhelp;

import com.fr.base.BaseUtils;
import com.fr.design.fun.impl.AbstractDsinFrameUpButtonProvider;
import com.fr.design.gui.ibutton.UIButton;
import com.fr.design.gui.icombobox.UIComboBox;
import com.fr.design.gui.ilable.UILabel;
import com.fr.design.gui.itextfield.UITextField;
import com.fr.design.mainframe.*;
import com.fr.design.utils.DesignUtils;
import com.fr.design.utils.gui.GUICoreUtils;
import com.fr.general.IOUtils;
import com.fr.locale.InterProviderFactory;
import com.fr.log.FineLoggerFactory;
import com.fr.plugin.cafe_expand.function.DoExpandFile;
import com.fr.plugin.cafe_expand.function.UnitTools;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.report.elementcase.TemplateElementCase;
import com.fr.report.poly.PolyECBlock;
import com.fr.third.springframework.util.FileCopyUtils;
import com.fr.third.springframework.util.StringUtils;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

/**
 * 设计器工具栏添加按钮
 * 弹出框配置扩展操作
 * */
@EnableMetrics
public class JumpToAnalysis extends AbstractDsinFrameUpButtonProvider {

    @Override
    public int currentAPILevel() {
        return CURRENT_LEVEL;
    }

    @Override
    public UIButton[] getUpButtons(int menuState) {
        UIButton btn = new UIButton(IOUtils.readIcon("/com/fr/design/images/m_web/cache.png"));
        btn.setToolTipText(InterProviderFactory.getProvider().getLocText("cafe_expand_assist"));
        btn.addActionListener(new AbstractAction() {
            @Override
            public void actionPerformed(ActionEvent e) {
                JTemplate<?, ?> template = DesignerContext.getDesignerFrame().getSelectedJTemplate();
                String filePath= template.getPath().replace("reportlets/","");

                String position="";

                if( template instanceof JWorkBook){
                    TemplateElementCase wb=((JWorkBook) template).getEditingElementCase();
                    int sheetNum=template.getEditingReportIndex()+1;
                    position="sheet:"+sheetNum;
                    String sheetKind=wb.getClass().toString();

                    if(sheetKind.contains("poly"))
                    {
                        PolyECBlock block = (PolyECBlock) wb;
                        position=position+",blockName:"+block.getBlockName();
                    }
                }
                else if(template instanceof JForm)
                    position="frm:"+template.getSelectElementCase().getWidgetName();

                JDialog fr = new JDialog();
                fr.setSize(400, 250);
                GUICoreUtils.centerWindow(fr);
                fr.setResizable(false);
                fr.setTitle(InterProviderFactory.getProvider().getLocText("cafe_expand_assist"));
                fr.setIconImage(BaseUtils.readImageWithCache("/com/fr/design/images/m_web/cache.png"));

                String[] item = new String[]{InterProviderFactory.getProvider().getLocText("insert"), InterProviderFactory.getProvider().getLocText("delete")};

                //路径 位置------------------------------------
                JPanel panel_path = new JPanel();
                panel_path.add(new UILabel(InterProviderFactory.getProvider().getLocText("local_path")));
                panel_path.add(new UILabel(filePath));

                JPanel panel_position = new JPanel();
                panel_position.add(new UILabel(InterProviderFactory.getProvider().getLocText("report_position")));
                panel_position.add(new UILabel(position));

                //插入列------------------------------------
                JPanel panel_col = new JPanel();

                panel_col.add(new UILabel(InterProviderFactory.getProvider().getLocText("col_expand")));

                String[] item_col = new String[]{"A列前", "A列后", "B列后", "C列后", "D列后", "E列后", "F列后", "G列后", "H列后", "I列后", "J列后", "K列后", "L列后", "M列后", "N列后", "O列后", "P列后", "Q列后", "R列后", "S列后", "T列后", "U列后", "V列后", "W列后", "X列后", "Y列后", "Z列后", "AA列后", "AB列后", "AC列后", "AD列后", "AE列后", "AF列后", "AG列后", "AH列后", "AI列后", "AJ列后", "AK列后", "AL列后", "AM列后", "AN列后", "AO列后", "AP列后", "AQ列后", "AR列后", "AS列后", "AT列后", "AU列后", "AV列后", "AW列后", "AX列后", "AY列后", "AZ列后"};
                UIComboBox col_position = new UIComboBox(item_col);
                panel_col.add(col_position);

                UIComboBox col_type = new UIComboBox(item);
                panel_col.add(col_type);

                UITextField col_num = new UITextField(5);
                panel_col.add(col_num);

                panel_col.add(new UILabel("列"));

                //插入行------------------------------------------------------------
                JPanel panel_row = new JPanel();

                panel_row.add(new UILabel(InterProviderFactory.getProvider().getLocText("row_expand")));

                UITextField row_position = new UITextField(3);
                panel_row.add(row_position);

                panel_row.add(new UILabel("行后"));

                UIComboBox row_type = new UIComboBox(item);
                panel_row.add(row_type);

                UITextField row_num = new UITextField(5);
                panel_row.add(row_num);

                panel_row.add(new UILabel("行"));

                //提交按钮------------------------------------------------------------
                JPanel panel_submit = new JPanel();
                UIButton button_row = new UIButton(InterProviderFactory.getProvider().getLocText("submit"));
                panel_submit.add(button_row);


                //结果展示----------------------------------------------------------
                JPanel panel_result=new JPanel();
                UILabel lable_result=new UILabel();
                panel_result.add(lable_result);


                String finalPosition = position;
                button_row.addActionListener(ee -> {
                    DoExpandFile d=new DoExpandFile();
                    String arr[]=new String[4];
                    arr[0]=filePath;
                    arr[1]= finalPosition;

                    String row = row_position.getText()+":"+row_type.getSelectedIndex()+":"+row_num.getText();
                    String col = col_position.getSelectedIndex()+":"+col_type.getSelectedIndex()+":"+col_num.getText();

                    if(StringUtils.isEmpty(col_num.getText()))
                        col="";
                    if(StringUtils.isEmpty(row_num.getText()))
                        row="";

                    //选了扩展多少行，但是没有没有选从哪一行开始扩展
                    if(StringUtils.isEmpty(row_position.getText()) && !StringUtils.isEmpty(row_num.getText()))
                        lable_result.setText(InterProviderFactory.getProvider().getLocText("row_not_select"));
                    else {
                        if (!StringUtils.isEmpty(row) || !StringUtils.isEmpty(col)) {
                            arr[2] = col;
                            arr[3] = row;

                            String result = d.run(arr).toString();
                            try {
                                DesignerFrameFileDealerPane.getInstance().getSelectedOperation().refresh();
                                DesignerFrameFileDealerPane.getInstance().stateChange();
                                lable_result.setText(InterProviderFactory.getProvider().getLocText("file_after_change") + result);
                            } catch (Exception e1) {
                                lable_result.setText(InterProviderFactory.getProvider().getLocText("error_info") + e1.getMessage());
                            }
                        } else
                            lable_result.setText(InterProviderFactory.getProvider().getLocText("attention_info"));
                    }
                });

                Box vBox = Box.createVerticalBox();
                vBox.add(panel_path);
                vBox.add(panel_position);
                vBox.add(panel_col);
                vBox.add(panel_row);
                vBox.add(panel_submit);
                vBox.add(panel_result);

                fr.add(vBox);
                fr.setModalityType(JDialog.ModalityType.APPLICATION_MODAL); // 设置模式类型。
                fr.setVisible(true);
            }
        });
        return new UIButton[]{
                btn
        };
    }
}