package com.fr.plugin.cafe_expand.function;

import com.fr.stable.StringUtils;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.List;
import java.util.Map;
/**
 * 工具
 * */
public class UnitTools {
    public static String colRow[] = { "A", "B", "C", "D", "E", "F", "G", "H",
            "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U",
            "V", "W", "X", "Y", "Z" };

    /**
     * 获取文件根节点
     * */
    public static Element getRootEle(String filePath)
    {
        SAXReader reader = new SAXReader();
        File file=new File(filePath);
        Document docXml=null;
        try {
            docXml = reader.read(file);
        } catch (DocumentException e) {
            e.printStackTrace();
        }
        Element rootEle = docXml.getRootElement();
        return rootEle;
    }

    /**
     * 根据行列组合单元格
     * */
    public static String getCafe(String col,String row)
    {
        int cols=Integer.parseInt(col);
        int rows=Integer.parseInt(row);

        int x = cols / 26;
        String firstStr = "";
        if (x > 0)
        {
            firstStr = colRow[x - 1];
            cols=cols-26*x;
        }
        String secStr = colRow[cols];
        String thirdStr = (rows + 1) + "";
        String cafe = firstStr + secStr + thirdStr;

        return cafe;
    }

    /**
     * 根据单元格获取列
     * */
    public static String getCol(String cafe)
    {
        String col="";
        for(int i=0;i<cafe.length();i++)
        {
            if(Character.isLetter(cafe.charAt(i)))
                col+=cafe.charAt(i);
            else
                break;
        }
        return col;
    }

    /**
     * 根据英文字母获取下标
     * */
    public static int getColNum(String col)
    {
        int num=0;
        int len=col.length();
        for(int i=0;i<len;i++)
        {
            String c=col.substring(0,1);
            for(int j=0;j<26;j++)
            {
                if(c.equals(colRow[j])){
                    num=num+j+26*(len-1-i);
                    break;
                }
            }
            col=col.replaceFirst(c,"");
        }
        return num;
    }


    /**
     * 自定义replace方法，替换字符串中的单元格
     * */
    public static String replaceCafe(String str,String before,String after)
    {
        int size=before.length();
        String newStr="";
        int len=str.length();
        int i=0;
        while(i<=len)
        {
            int start=str.indexOf(before);
            if(start==-1){
                newStr+=str;
                break;
            }
            else if(start+size<len)
            {
                char character=str.charAt(start+size);
                if(!Character.isDigit(character))
                {
                    String temp=str.substring(0,start+size);
                    newStr=newStr+temp.replace(before,after);
                }
                else
                    newStr+=str;
                str=str.substring(start+size);
            }
            else if(start+size==len)
                newStr=newStr+str.replace(before,after);

            i=i+start+size+1;
        }
        return newStr;
    }

    /**
     * 从字符串中提取单元格 如A1
     * isDigit 判断数值；isLetter 判断英文字母
     * 根据模板实际情况，最大ZZ99；
     * */
    public static void getCellCafe(String strs, List<String> cafeList)
    {
        if(!StringUtils.isEmpty(strs)) {
            String cafe = "";
            int beg = 0;
            int end = 0;
            int len = strs.length();
            for (int i = 0; i < len; i++) {
                char character = strs.charAt(i);
                if (Character.isLetter(character) && ((i > 1 && !Character.isLetterOrDigit(strs.charAt(i - 1))) || i <= 1)) {//第一个是字母,且前一个不是字符，或空
                    beg = i;
                    if (i < (len - 1)) {
                        char secondC = strs.charAt(i + 1);//第二个字符
                        if (Character.isDigit(secondC))//可能是数字 A1
                        {
                            if (i < (len - 2))//第三个字符
                            {
                                char thirdC = strs.charAt(i + 2);
                                if (Character.isDigit(thirdC))//还是数字A11
                                {
                                    if (i < (len - 3)) {
                                        char fourthC = strs.charAt(i + 3);
                                        if (!Character.isLetterOrDigit(fourthC))//不是字符，也不是数字
                                        {
                                            end = i + 3;
                                            cafe = character + secondC + thirdC + "";
                                        }
                                    } else {
                                        end = i + 3;
                                        cafe = character + secondC + thirdC + "";
                                    }
                                } else if (!Character.isLetterOrDigit(thirdC))//不是字符，也不是数字
                                {
                                    end = i + 2;
                                    cafe = character + secondC + "";
                                }
                            } else {
                                end = i + 2;
                                cafe = character + secondC + "";
                            }
                        } else if (Character.isLetter(secondC))//可能是字符 如AB1
                        {
                            if (i < (len - 2))//第三个字符,只能是数字
                            {
                                char thirdC = strs.charAt(i + 2);
                                if (Character.isDigit(thirdC))//是数字AB1
                                {
                                    if (i < (len - 3))//第4个字符
                                    {
                                        char fourthC = strs.charAt(i + 3);
                                        if (!Character.isLetterOrDigit(fourthC))//不是字符，也不是数字
                                        {
                                            end = i + 3;
                                            cafe = character + secondC + thirdC + "";
                                        } else if (Character.isDigit(fourthC))//还是数字 AB11
                                        {
                                            if (i < (len - 4)) {
                                                char fifthC = strs.charAt(i + 4);
                                                if (!Character.isLetterOrDigit(fifthC))//不是字符，也不是数字
                                                {
                                                    end = i + 4;
                                                    cafe = character + secondC + thirdC + fourthC + "";
                                                }
                                            } else {
                                                end = i + 4;
                                                cafe = character + secondC + thirdC + fourthC + "";
                                            }
                                        }
                                    } else {
                                        end = i + 3;
                                        cafe = character + secondC + thirdC + "";
                                    }
                                }
                            }
                        }
                    }
                }
                if (!"".equals(cafe))
                    break;
            }
            if (end > beg){
                String temp_cafe=strs.substring(beg, end);
                if(!temp_cafe.startsWith("ds") || !strs.contains("dsName"))//如果查出来的cafe是 ds1 这种数据集，要去除
                    cafeList.add(temp_cafe);
            }
            if (!"".equals(cafe)) {
                String nextStr = strs.substring(end);
                getCellCafe(nextStr, cafeList);
            }
        }
    }


    /**
     * 填报中单元格给的格式
     * */
    public static String getcafeStr(String cafe){
        int colRow[] = getColRow(cafe);
        return "<ColumnRow column=\""+colRow[0]+"\" row=\""+colRow[1]+"\"/>";
    }

    /**
     * 获取单元格行列
     * */
    public static int[] getColRow(String cafe)
    {
        int colRow[]=new int[2];
        String col= UnitTools.getCol(cafe);
        colRow[0]= UnitTools.getColNum(col);
        colRow[1]=Integer.parseInt(cafe.replace(col,""))-1;

        return colRow;
    }

    /**
     * 需要变更的cafe排序
     * 比如C2->C3,C3->C4
     * 要先处理C3->C4
     * LinkedHashMap 按顺序读写
     * */
    public static void sortExpandCafe(Map<String, String> map, Map<String, String> newmap)
    {
        for (Map.Entry<String, String> entry : map.entrySet()) {
            String v=entry.getValue();
            String k=entry.getKey();

            map.remove(k);

            if(map.containsKey(v))
            {
                map.put(k,v);
                sortExpandCafe(map,newmap);
                break;
            }
            else{
                newmap.put(k,v);
                sortExpandCafe(map,newmap);
                break;
            }
        }
    }

    /**
     * 判断getValue(a,b,c)是否要替换
     * a=sheetNum才替换
     * */
    public static boolean judgeSheet(String cafe,int sheetNum)
    {
        boolean judge=true;
        try {
            if (cafe.startsWith("(") && sheetNum!=-1) {
                cafe = cafe.replace("(", "").replace(")", "").replace(" ", "");
                String arr[] = cafe.split(",");
                if (!arr[2].startsWith("\"") && !arr[2].startsWith("'"))//第三个是字符串，说明是setvalue，不用管
                {
                    int sheet = Integer.parseInt(arr[0]);
                    if (sheetNum != sheet)//同一个sheet才替换
                        judge = false;
                }
            }
        }catch (Exception e){}
        return judge;
    }

    /**
     * 拷贝文件
     * */
    public static void copyFile(String oldPath, String newPath) {
        try {
            File oldfile = new File(oldPath);
            if (oldfile.exists()) {
                InputStream inStream = new FileInputStream(oldPath);

                File nfile=new File(newPath);
                if(nfile.exists())
                    nfile.delete();
                nfile.getParentFile().mkdir();

                FileOutputStream fileOfutputStream = new FileOutputStream(newPath);
                byte[] buffer = new byte[1024];
                int length;
                while ((length = inStream.read(buffer)) != -1) {
                    fileOfutputStream.write(buffer, 0, length);
                }
                inStream.close();
                fileOfutputStream.close();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void writeToMb(String sbs,String path)
    {
        try {
            FileOutputStream out = new FileOutputStream(path, true);
            out.write(sbs.getBytes("utf-8"));
            out.flush();
            out.close();
        }
        catch (Exception e)
        {}
    }
}
